module HearthstoneCardApi
  
  require_relative 'helpers/configuration'
  require_relative 'hearthstone_card_api/caller'
  require_relative 'hearthstone_card_api/data'
  require 'unirest'
  extend Configuration
  
  define_setting :api_key
  define_setting :data_format, "objects"

  class Public

    attr_accessor :call

    def initialize(args={})
      @call = HearthstoneCardApi::Caller.new
    end

    def get_info
      url = "info"
      call.return_info(url)
    end

    def get_cards(args={})
      url = "cards"
      args[:url] = url
      call.return_cards(args)
    end

    def search_cards(args={}) #expects {:name}
      name = args[:name]
      url= "cards/search/#{name}"
      args[:url] = url
      call.return_cards(args)
    end

    def get_cards_by(args={}) #expects {:trait, :value}
      trait = args[:trait]
      value = args[:value]
      url= "cards/#{trait}/#{value}"
      args[:url] = url
      call.return_cards(args)
    end

    def get_card_by_id(args={}) #expects {:id}
      url = "cards/#{args[:id]}"
      args[:url] = url
      data = call.return_cards(args)
      if data.is_a? Hash or data.is_a? String #if 404 error, hash, or string
        return data
      else 
        return data[0] #else return single obj
      end
    end

    def get_card_by_name(args={}) #expects {:name}
      name = args[:name]
      url = "cards/#{name}"
      args[:url] = url
      call.return_cards(args)
    end
  end
end
