module HearthstoneCardApi

  class Caller
    attr_accessor :api_url, :api_key, :filters, :collectible
    
    def initialize(args={})
      @api_key = HearthstoneCardApi.api_key 
      @api_url = "https://omgvamp-hearthstone-v1.p.mashape.com/"

      @collectible = "1"
      @filters = {cost: nil, attack: nil, health: nil, durability: nil}
    end

    def return_cards(args={}) 
      url = add_filters_to_url(args)
      api_response(endpoint(url))
    end

    def return_info(url)
      api_response(endpoint(url))
    end

    private
      def add_filters_to_url(args={})
        url = args[:url]
        arg_filters = args[:filters] || {}
        arg_collectible = args[:collectible] || "1"
        url += "?"
        url += "&collectible=#{arg_collectible}"
        arg_filters.each do |key, value|
          if !value.nil?
            url += "&#{key}=#{value}" 
          end
        end
        return url
      end

      def api_response(url_param)
        url = url_param
        response = Unirest.get url,
          headers:{
            "X-Mashape-Key" => api_key} 
        data = HearthstoneCardApi::Data.new(response)
        return data.formatted
      end

      def endpoint(url_param)
        api_url + url_param
      end
  end
end
